package es.um.atica.miproyecto.security.authorization.services;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.log.Log;

import es.um.atica.enclave2.security.authorization.das.interfaces.RestTokenDataAccessService;
import es.um.atica.enclave2.security.authorization.das.interfaces.RestUsuariosDataAccessService;
import es.um.atica.enclave2.security.rest.authorization.entities.RestUsuarioToken;
import es.um.atica.enclave2.security.rest.authorization.entities.RestUsuarios;

@LocalBean
@Stateless
@Name( "servicioAutorizacionRest" )
public class ServicioAutorizacionRest {

    @Logger
    private Log log;

    @In(
        value = "restUsuariosDataAccessService", create = true )
    private RestUsuariosDataAccessService restUsuariosDataAccessService;

    @In(
        value = "restTokenDataAccessService", create = true )
    private RestTokenDataAccessService restTokenDataAccessService;

    public RestUsuarios obtenerUsuario( String usuario ) {
        return this.restUsuariosDataAccessService.obtenerUsuario( usuario );
    }

    public String generaTokenUsuario( RestUsuarios usuario ) {
        return restTokenDataAccessService.generaTokenUsuario( usuario );
    }

    public boolean autenticaTokenUsuario( RestUsuarios usuario, String token ) {
        RestUsuarioToken tokenUsuairo = this.restTokenDataAccessService.obtenerTokenValidoDeUsuario( usuario );
        if ( tokenUsuairo == null ) {
            return false;
        }
        else {
            return token.equals( tokenUsuairo.getToken() );
        }
    }

}
